searchNodes=[{"doc":"Functions to query and stream requests using Humiex search API","ref":"Humiex.html","title":"Humiex","type":"module"},{"doc":"Creates a new Humiex.ClientTakes a Hostname, Repository Name, Token and optionsexampleiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) %Humiex.Client{ headers: [ {&quot;authorization&quot;, &quot;Bearer my_token&quot;}, {&quot;Content-Type&quot;, &quot;application/json&quot;}, {&quot;Accept&quot;, &quot;application/x-ndjson&quot;} ], http_client: Humiex.Runner.HTTPClient, repo: &quot;my_repo&quot;, token: &quot;my_token&quot;, url: &quot;https://my-humio-host.com/api/v1/repositories/my_repo/query&quot; }","ref":"Humiex.html#new_client/4","title":"Humiex.new_client/4","type":"function"},{"doc":"Makes a search request to the Humio API and returns the events and state synchronouslyTakes a Humiex.Client configuration, Query String, Start Time, End Time and optionsexamplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; relative_start = &quot;1s&quot; iex&gt; {:ok, relative_events, relative_state} = Humiex.query(client, query_string, relative_start) iex&gt; absolute_start = 1604447249 iex&gt; {:ok, absolute_events, absolute_state} = Humiex.query(client, query_string, absolute_start)","ref":"Humiex.html#query/5","title":"Humiex.query/5","type":"function"},{"doc":"Makes a search request to the Humio API and synchronously returns only the eventsTakes a Humiex.Client configuration, Query String, Start Time, End Time and optionsexamplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; relative_start = &quot;1s&quot; iex&gt; relative_events = Humiex.query_values(client, query_string, relative_start) iex&gt; absolute_start = 1604447249 iex&gt; absolute_events = Humiex.query_values(client, query_string, absolute_start)","ref":"Humiex.html#query_values/5","title":"Humiex.query_values/5","type":"function"},{"doc":"Makes a live search request to the Humio API and asynchronously returns the event and stateTakes a previous Humiex.State and continues from where it left off based on the last_timestamp and latest_idsEach streamed result have the shape: %{value: event, state: state}examplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; relative_start = &quot;1s&quot; iex&gt; [%{state: state}] = Humiex.stream(client, query_string, relative_start) |&gt; Enum.take(1) iex&gt; next_events = Humiex.stream(state) |&gt; Enum.take(100)","ref":"Humiex.html#stream/1","title":"Humiex.stream/1","type":"function"},{"doc":"Makes a live search request to the Humio API and asynchronously returns the event and stateTakes a Humiex.Client configuration, Query String, Start Time and optionsEach streamed result have the shape: %{value: event, state: state}examplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; relative_start = &quot;1s&quot; iex&gt; relative_start_stream = Humiex.stream(client, query_string, relative_start) iex&gt; stream |&gt; Enum.take(3) iex&gt; absolute_start = 1604447249 iex&gt; absolute_start_stream = Humiex.stream(client, query_string, absolute_start) iex&gt; absolute_start_stream |&gt; Enum.take(3)","ref":"Humiex.html#stream/4","title":"Humiex.stream/4","type":"function"},{"doc":"Makes a live search request to the Humio API and asynchronously returns the eventsTakes a previous Humiex.State and continues from where it left off based on the last_timestamp and latest_idsEach streamed result is one humio event.The State is sent as a message {:updated_humio_query_state, state} for each event streamed. The message is sent to the process specified in the State option :state_dest (current process by default)examplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; relative_start = &quot;1s&quot; iex&gt; [%{value: _value, state: state}] = Humiex.stream(client, query_string, relative_start) |&gt; Enum.take(1) iex&gt; next_events = Humiex.stream_values(state) |&gt; Enum.take(100) [ %{...}, ... ] iex&gt; flush ... {:updated_humio_query_state, %Humiex.State{...}} :ok","ref":"Humiex.html#stream_values/1","title":"Humiex.stream_values/1","type":"function"},{"doc":"Makes a live search request to the Humio API and asynchronously returns the eventsTakes a Humiex.Client configuration, Query String, Start Time and optionsEach streamed result is one humio event.The State is sent as a message {:updated_humio_query_state, state} for each event streamed. The message is sent to the current process by default, a custom recipient pid can be passed using the opt :state_destexamplesiex&gt; client = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;) iex&gt; query_string = &quot;#env=dev #type=log foo&quot; iex&gt; start = &quot;1s&quot; iex&gt; stream = Humiex.stream_values(client, query_string, start) iex&gt; [event] = stream |&gt; Enum.take(1) [ %{...} ] iex&gt; flush ... {:updated_humio_query_state, %Humiex.State{...}} :ok iex&gt; {:ok, pid} = Task.start(fn -&gt; ...&gt; receive do ...&gt; {:updated_humio_query_state, state} -&gt; IO.inspect(state) ...&gt; _ -&gt; :ok ...&gt; end end) iex&gt; stream = Humiex.stream(client, query_string, start, state_dest: pid) iex&gt; stream |&gt; Enum.take(1) %Humiex.State{...} [ %{...} ]","ref":"Humiex.html#stream_values/4","title":"Humiex.stream_values/4","type":"function"},{"doc":"","ref":"Humiex.html#t:maybe_time/0","title":"Humiex.maybe_time/0","type":"type"},{"doc":"","ref":"Humiex.html#t:relative_time/0","title":"Humiex.relative_time/0","type":"type"},{"doc":"","ref":"Humiex.html#t:time/0","title":"Humiex.time/0","type":"type"},{"doc":"Humiex Client configurationStores the url, repo and token needed to use the Search API","ref":"Humiex.Client.html","title":"Humiex.Client","type":"module"},{"doc":"","ref":"Humiex.Client.html#new/4","title":"Humiex.Client.new/4","type":"function"},{"doc":"","ref":"Humiex.Client.html#t:header/0","title":"Humiex.Client.header/0","type":"type"},{"doc":"","ref":"Humiex.Client.html#t:t/0","title":"Humiex.Client.t/0","type":"type"},{"doc":"","ref":"Humiex.Client.html#t:token/0","title":"Humiex.Client.token/0","type":"type"},{"doc":"","ref":"Humiex.HTTPAsyncBehaviour.html","title":"Humiex.HTTPAsyncBehaviour","type":"behaviour"},{"doc":"","ref":"Humiex.HTTPAsyncBehaviour.html#c:next/1","title":"Humiex.HTTPAsyncBehaviour.next/1","type":"callback"},{"doc":"","ref":"Humiex.HTTPAsyncBehaviour.html#c:start/1","title":"Humiex.HTTPAsyncBehaviour.start/1","type":"callback"},{"doc":"","ref":"Humiex.HTTPAsyncBehaviour.html#c:stop/1","title":"Humiex.HTTPAsyncBehaviour.stop/1","type":"callback"},{"doc":"Sync functions to query Humiex Search results","ref":"Humiex.Query.html","title":"Humiex.Query","type":"module"},{"doc":"","ref":"Humiex.Query.html#query/5","title":"Humiex.Query.query/5","type":"function"},{"doc":"","ref":"Humiex.Query.html#query_values/5","title":"Humiex.Query.query_values/5","type":"function"},{"doc":"Stores a Humiex Query/Stream search stateAllows Humiex.stream/1 and Humiex.stream_values/1 to resume a Search from a previous one","ref":"Humiex.State.html","title":"Humiex.State","type":"module"},{"doc":"","ref":"Humiex.State.html#t:absolute_time/0","title":"Humiex.State.absolute_time/0","type":"type"},{"doc":"","ref":"Humiex.State.html#t:event_id/0","title":"Humiex.State.event_id/0","type":"type"},{"doc":"","ref":"Humiex.State.html#t:maybe_time/0","title":"Humiex.State.maybe_time/0","type":"type"},{"doc":"","ref":"Humiex.State.html#t:relative_time/0","title":"Humiex.State.relative_time/0","type":"type"},{"doc":"A Humiex State struct stores the client and query configuration alongside execution metadata such as the latest seen event timestamp and event ids:client Humiex Client configuration:query_string Humio search API queryString:start_time Humio search API start time specification:end_time Humio search API end time specification:opts Keyword of additional options such as:live? uses a live query if set to true:state_dest allows to send the Humiex.State as a message to a process when using stream_values/4:resp Holds a reference to the Client that implements HTTPAsyncBehaviour and it's used to execute the requests:last_timestamp Last seen timestamp:latest_ids List of the seen event ids for the last timestamp:event_count Number of events returned so far:chunk Internal buffer used to hold the raw api responses before decoding the events","ref":"Humiex.State.html#t:t/0","title":"Humiex.State.t/0","type":"type"},{"doc":"","ref":"Humiex.State.html#t:time/0","title":"Humiex.State.time/0","type":"type"},{"doc":"Async functions to Stream Humiex Search results","ref":"Humiex.Stream.html","title":"Humiex.Stream","type":"module"},{"doc":"","ref":"Humiex.Stream.html#stream/1","title":"Humiex.Stream.stream/1","type":"function"},{"doc":"","ref":"Humiex.Stream.html#stream/4","title":"Humiex.Stream.stream/4","type":"function"},{"doc":"","ref":"Humiex.Stream.html#stream_values/1","title":"Humiex.Stream.stream_values/1","type":"function"},{"doc":"","ref":"Humiex.Stream.html#stream_values/4","title":"Humiex.Stream.stream_values/4","type":"function"},{"doc":"","ref":"Humiex.Stream.html#to_query/1","title":"Humiex.Stream.to_query/1","type":"function"},{"doc":"HumiexHumio searches using it's REST API Supports sync queries and streaming live queries","ref":"readme.html","title":"Humiex","type":"extras"},{"doc":"Add to your dependenciesdeps = [ ... {:humiex, &quot;~&gt; 0.1.0&quot;}, ... ]","ref":"readme.html#installation","title":"Humiex - Installation","type":"extras"},{"doc":"Create a Humio Clientclient = Humiex.new_client(&quot;https://my-humio-host.com&quot;, &quot;my_repo&quot;, &quot;my_token&quot;)Query start = &quot;1s&quot; query_string = &quot;#env=dev #type=log foo&quot; # Search all logs in the last second on dev environment that have &quot;foo&quot; {:ok, events, state} = Humiex.query(client, query_string, start)To only get the events: start = &quot;1s&quot; query_string = &quot;#env=dev #type=log foo&quot; events = Humiex.query_values(client, query_string, start)StreamTurn it into a live query: start = &quot;1s&quot; query_string = &quot;#env=dev #type=log foo&quot; event_stream = Humiex.stream_values(client, query_string, start) last_10_events = event_stream |&gt; Enum.take(10)This code was brought to you by BlockFi, the best way to earn on crypto and grow your wealth.","ref":"readme.html#usage","title":"Humiex - Usage","type":"extras"}]